<template>
  <Head>
    <Link rel="stylesheet" type="text/css" :href="seo.seo_color" />
    <Title>{{ seo.seo_title }}</Title>
    <Link
      rel="icon"
      type="image/png"
      :href="seo.seo_favicon.ImagePath"
      sizes="32x32"
    />
    <Link
    v-if="!seo.seo_canonical_tag.IsHidden"
    rel="canonical"
    :href="seo.seo_canonical_tag.HyperLink"
    />
    <Link
      v-if="device.isAndroid"
      rel="shortcut icon"
      :href="getShortcutIcon()"
      type="image/png"
      sizes="192x192"
    />
    <Link
      v-else
      rel="apple-touch-icon"
      :href="getShortcutIcon()"
      type="image/png"
      sizes="192x192"
    />   
    <Meta name="viewport"  />
    <Meta name="keywords" :content="seo.seo_keywords" />
    <Meta name="description" :content="seo.seo_description" />
    <Meta name="dc.title" :content="seo.seo_title" />
    <Meta name="dc.subject" :content="seo.seo_title" />
    <Meta name="dc.keywords" :content="seo.seo_keywords" />
    <Meta name="dc.description" :content="seo.seo_description" />
    <Meta name="dc.publisher" :content="seo.seo_brand_name" />
    <Meta name="dc.contributor" :content="seo.seo_brand_name" />
    <Meta name="dc.creator.name" :content="seo.seo_brand_name" />
    <Meta name="dc.type" content="Text" />
    <Meta name="dc.language" :content="seo.seo_language" />
    <Meta property="og:type" content="website" />
    <Meta property="og:locale" content="en_US" />
    <Meta property="og:title" :content="seo.seo_title" />
    <Meta property="og:url" :content="seo.seo_url" />
    <Meta property="og:description" :content="seo.seo_description" />
    <Meta property="og:image" :content="getSeoImagePath()" />
    <Meta property="og:site_name" :content="seo.seo_title" />
    <Meta name="twitter:card" content="summary_large_image" />
    <Meta name="twitter:title" :content="seo.seo_title" />
    <Meta name="twitter:description" :content="seo.seo_description" />
    <Meta name="author" :content="seo.seo_brand_name" />
    <Meta name="copyright" :content="seo.seo_brand_name" />
    <Meta name="webcrawlers" content="all" />
    <Meta name="spiders" content="all" />
    <Meta name="allow-search" content="yes" />
    <Meta name="robots" content="index,follow" />
    <Meta name="googlebot" content="index,follow" />
    <Meta name="YahooSeeker" content="index,follow" />
    <Meta name="msnbot" content="index,follow" />
    <Meta name="expires" content="never" />
    <Meta name="publisher" :content="seo.seo_brand_name" />
    <Meta name="language" :content="seo.seo_language" />
    <Meta name="rating" content="general" />
    <Meta name="publisher" :content="seo.seo_brand_name" />
    <Meta name="tgn.nation" :content="seo.seo_nation" />
    <Meta name="geo.country" :content="seo.seo_country" />
    <Meta name="geo.region" :content="seo.seo_region" />
    <Meta name="geo.placename" :content="seo.seo_placename" />
    <Meta
      name="google-site-verification"
      :content="seo.google_site_verification"
    />
  </Head>
</template>
<script lang="ts" setup>
import { IThemePropertiesFromApi } from "~~/models/companyThemePropertiesRespone";
import { store } from '@/store';

const props = defineProps({
  themeProperties: {
    type: Array<IThemePropertiesFromApi>,
    default: [],
  },
  colorConfig: {
    type: String,
    default: "",
  },
});
const { themeProperties: themeProp, colorConfig } = props;
const seo = {
    seo_keywords: themePropertyHelper.getSingleThemeProperty(
      themeProp,
      "seo_keywords"
    ).Text,
    seo_description: themePropertyHelper.getSingleThemeProperty(
      themeProp,
      "seo_description"
    ).Text,
    seo_title: themePropertyHelper.getSingleThemeProperty(
      themeProp,
      "seo_title"
    ).Text,
    seo_brand_name: themePropertyHelper.getSingleThemeProperty(
      themeProp,
      "seo_brand_name"
    ).Text,
    seo_language: themePropertyHelper.getSingleThemeProperty(
      themeProp,
      "seo_language"
    ).Text,
    seo_url: themePropertyHelper.getSingleThemeProperty(themeProp, "seo_url")
      .Text,
    seo_imagePath: themePropertyHelper.getSingleThemeProperty(
      themeProp,
      "seo_imagepath"
    ),
    seo_nation: themePropertyHelper.getSingleThemeProperty(
      themeProp,
      "seo_tgn_nation"
    ).Text,
    seo_country: themePropertyHelper.getSingleThemeProperty(
      themeProp,
      "seo_geo_country"
    ).Text,
    seo_region: themePropertyHelper.getSingleThemeProperty(
      themeProp,
      "seo_geo_region"
    ).Text,
    seo_placename: themePropertyHelper.getSingleThemeProperty(
      themeProp,
      "seo_geo_placename"
    ).Text,
    google_site_verification: themePropertyHelper.getSingleThemeProperty(
      themeProp,
      "seo_google_site_verification"
    ).Text,
    seo_favicon: themePropertyHelper.getSingleThemeProperty(
      themeProp,
      "fav_icon"
    ),
    seo_color: colorConfig,
    seo_shortcut_icon: themePropertyHelper.getSingleThemeProperty(
      themeProp,
      "seo_shortcut_icon"
    ),
    seo_canonical_tag: themePropertyHelper.getSingleThemeProperty(
      themeProp,
      "seo_canonical_tag"
    ),
  };

const getShortcutIcon = (): string => {
  return seo?.seo_shortcut_icon.IsHidden
    ? seo?.seo_favicon?.ImagePath
    : seo?.seo_shortcut_icon?.ImagePath;
};
const getSeoImagePath = (): string => {
  return seo?.seo_imagePath.IsHidden ? '' : seo.seo_imagePath.Text;
};
const device = useDevice();

const preventZoom = () => {
  let width = Math.max(window.screen.width, window.innerWidth);
  width = width * window.devicePixelRatio;
  let content = "";
  if (store.state.isPerushopEnabled && store.state.selectedThemeName.includes("global")) {
    if (width < 1280) {
      content = "width=1280, user-scalable=no";
    } else {
      content = `width=${width}, user-scalable=no`;
    }
  } else {
    // Default one
    content = "width=device-width, initial-scale=1, maximum-scale=1";
  }
  const metaViewport = document.querySelector('meta[name="viewport"]');

  metaViewport.content = content;
};
setTimeout(() => {
  preventZoom();
}, 200);
</script>
